        .586                            ; Create 32 bit code
        .model  flat, stdcall           ; 32 bit memory model
        option  casemap :none           ; Case sensitive
 
        include \masm32\include\windows.inc
        include \masm32\include\user32.inc
        include \masm32\include\kernel32.inc

        includelib \masm32\lib\user32.lib
        includelib \masm32\lib\kernel32.lib

MyProg      PROTO
infrosort   PROTO :DWORD, :DWORD

.code

Start:  invoke  MyProg
        invoke  ExitProcess, NULL

MyProg  proc    uses edi
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        local   OurMem
        local   OurString[1024]:Byte

        invoke  VirtualAlloc, NULL, 010000h, MEM_COMMIT, PAGE_READWRITE
        mov     edi, eax
        mov     ecx, 03fffh
@@:     call    Random
        mov     [edi+ecx*4], eax
        loop    @B
        call    Random
        mov     [edi], eax
        invoke  infrosort, edi, 10000h
        invoke  wsprintf, addr OurString, "%x", [OurMem]
        add     esp, 12
        invoke  MessageBox, NULL, addr OurString, NULL, MB_OK
        invoke  VirtualFree, [OurMem], 010000h, MEM_DECOMMIT
        invoke  CloseHandle, [OurMem]
        ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MyProg  ENDP

infrosort proc pArray,right ;right is the arraysize not arrayelements (assumed DWORDs)
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        LOCAL   left, location

        pushad
        xor     eax, eax
        mov     [left], eax             ; Left = 0
        shr     DWORD PTR [right], 2    ; Right = array elements
        mov     esi, [pArray]           ; esi=&array
L1:                                     ; Do{
        mov     ecx, [left]             ; templeft=left
        mov     eax, [esi+ecx*4]        ; eax=array[left]
        mov     [location], ecx         ; Save templeft in location
L2:     cmp     ecx, [right]            ; While templeft < right, else go to E1
        jge     E1
        cmp     [esi+ecx*4], eax        ; If array[templeft] <= eax goto L3
        jng     L3
        mov     [location], ecx         ; If array[templeft] > eax, save templeft in location
        mov     eax, [esi+ecx*4]        ; If array[templeft] > eax, save array[templeft] in eax
L3:     add     ecx, 1                  ; templeft++
        jmp     L2                      ; End While
E1:     sub     DWORD PTR [right], 1    ; right--
        sub     ecx, 1                  ; storelocation=templeft-1
        mov     ebx, [location]         ; ecx=oldtempleft
        cmp     ebx, ecx
        jz      @F
        mov     edx, [esi+ecx*4]        ; temp=array[storelocation]
        mov     [esi+ecx*4], eax        ; array[storelocation]=array[oldtempleft]
;       mov     ebx, [location]         ; ecx=oldtempleft
        mov     [esi+ebx*4], edx        ; array[oldtempleft]=temp
@@:
A1:     mov     ecx, [right]            ; tempright=right
        mov     eax, [esi+ecx*4]        ; eax=array[right]
        mov     [location], ecx         ; Save tempright in location
A2:     cmp     ecx, [left]             ; While tempright > left, else goto E2
        jle     E2
        cmp     [esi+ecx*4], eax        ; if array[tempright] >= eax goto A3
        jnl     A3
        mov     [location], ecx         ; if array[tempright] < eax, save tempright
        mov     eax, [esi+ecx*4]        ; if array[tempright] < eax, save array[tempright]
A3:     sub     ecx, 1                  ; tempright ++
        jmp     A2                      ; End While
E2:     add     DWORD PTR [left], 1     ; left--
        mov     ebx, [location]         ; ecx=oldtempleft
        cmp     ecx, ebx
        jz      @F
        mov     edx, [esi+ecx*4]        ; temp=array[storelocation]
        mov     [esi+ecx*4], eax        ; array[storelocation]=array[oldtempright]
;       mov     ebx, [location]         ; ecx=oldtempleft
        mov     [esi+ebx*4], edx        ; array[oldtempleft]=temp
@@:     mov     ecx, [left]
        cmp     ecx, [right]            ; }While left >=right
        jng     L2
        popad
        ret
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
infrosort ENDP

Random: push    edx
        push    ecx
        RDTSC
        and     eax, 0000ffffh
        mov     ecx, eax
@@:     loop    @B
        RDTSC
        pop     ecx
        pop     edx
        and     eax, 0000ffffh
        ret

        END     Start

